From 2afee4233e8138e70b91dee1413a32c71ec2166b Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 12:54:44 +0100
Subject: [PATCH 04/54] feat: boxed-list style for info page

---
 lact-gui/src/app/mod.rs                       |   5 +-
 lact-gui/src/app/page_section.rs              |   3 -
 lact-gui/src/app/root_stack/info_page/mod.rs  | 317 ++++++++++--------
 .../root_stack/info_page/vulkan_info/mod.rs   |  87 ++---
 lact-gui/src/app/root_stack/mod.rs            |  10 +-
 lact-gui/ui/page_section.blp                  |   8 +-
 6 files changed, 227 insertions(+), 203 deletions(-)

diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index 244c697e..219bb0f7 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -43,8 +43,10 @@ impl App {
         let toolbars = Toolbars::new();
         let window = libadwaita::ApplicationWindow::builder()
             .title("LACT")
-            .default_width(600)
+            .default_width(700)
             .default_height(820)
+            .width_request(300)
+            .height_request(200)
             .icon_name(APP_ID)
             .build();
 
@@ -104,6 +106,7 @@ impl App {
             .sidebar(
                 &libadwaita::NavigationPage::builder()
                     .child(&sidebar_view)
+                    .title("LACT")
                     .build(),
             )
             .content(
diff --git a/lact-gui/src/app/page_section.rs b/lact-gui/src/app/page_section.rs
index 22155e16..489eba49 100644
--- a/lact-gui/src/app/page_section.rs
+++ b/lact-gui/src/app/page_section.rs
@@ -67,9 +67,6 @@ mod imp {
             let obj = self.obj();
 
             obj.bind_property("name", &self.section_label.get(), "label")
-                .transform_to(|_, value: String| {
-                    Some(format!("<span font_desc='13'><b>{value}</b></span>"))
-                })
                 .build();
         }
     }
diff --git a/lact-gui/src/app/root_stack/info_page/mod.rs b/lact-gui/src/app/root_stack/info_page/mod.rs
index 4ca3b532..de125e58 100644
--- a/lact-gui/src/app/root_stack/info_page/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/mod.rs
@@ -1,31 +1,58 @@
 mod vulkan_info;
 
-use super::{label_row, values_grid};
 use crate::app::page_section::PageSection;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::{DeviceInfo, DeviceStats};
+use libadwaita::prelude::ActionRowExt;
 use vulkan_info::VulkanInfoFrame;
 
+#[derive(Clone)]
+pub struct InfoRow {
+    pub container: libadwaita::ActionRow,
+    content_label: Label,
+}
+
+impl InfoRow {
+    pub fn new(title: &str) -> Self {
+        let container = libadwaita::ActionRow::builder().title(title).build();
+        let label = Label::builder()
+            .css_classes(["dim-label"])
+            .ellipsize(pango::EllipsizeMode::End)
+            .selectable(true)
+            .build();
+        container.add_suffix(&label);
+
+        Self {
+            container,
+            content_label: label,
+        }
+    }
+
+    pub fn set_content(&self, content: &str) {
+        self.content_label.set_label(content);
+    }
+}
+
 #[derive(Clone)]
 pub struct InformationPage {
     pub container: ScrolledWindow,
-    gpu_name_label: Label,
-    gpu_manufacturer_label: Label,
-    family_name: Label,
-    asic_name: Label,
-    vbios_version_label: Label,
-    driver_label: Label,
-    vram_size_label: Label,
-    vram_type_label: Label,
-    vram_peak_bw_label: Label,
-    compute_units_label: Label,
-    l1_cache_label: Label,
-    l2_cache_label: Label,
-    l3_cache_label: Label,
-    resizable_bar_enabled: Label,
-    cpu_accessible_vram_label: Label,
-    link_speed_label: Label,
+    gpu_name_row: InfoRow,
+    gpu_manufacturer_row: InfoRow,
+    family_name_row: InfoRow,
+    asic_name_row: InfoRow,
+    vbios_version_row: InfoRow,
+    driver_row: InfoRow,
+    vram_size_row: InfoRow,
+    vram_type_row: InfoRow,
+    vram_peak_bw_row: InfoRow,
+    compute_units_row: InfoRow,
+    l1_cache_row: InfoRow,
+    l2_cache_row: InfoRow,
+    l3_cache_row: InfoRow,
+    resizable_bar_enabled_row: InfoRow,
+    cpu_accessible_vram_row: InfoRow,
+    link_speed_row: InfoRow,
     vulkan_info_frame: VulkanInfoFrame,
     vulkan_unavailable_label: Label,
 }
@@ -34,44 +61,53 @@ impl InformationPage {
     pub fn new() -> Self {
         let vbox = Box::builder()
             .orientation(Orientation::Vertical)
-            .spacing(15)
-            .margin_start(20)
-            .margin_end(20)
+            .spacing(12)
             .build();
 
         let info_container = PageSection::new("Hardware Information");
 
-        let values_grid = values_grid();
-
-        // Dummy label to prevent the gpu name label from stealing focus
-        let dummy_label = Label::builder().selectable(true).halign(Align::End).build();
-        values_grid.attach(&dummy_label, 0, 0, 1, 1);
-
-        let mut row = 0;
-        let gpu_name_label = sequential_label_row("GPU Model:", &values_grid, &mut row);
-        let gpu_manufacturer_label =
-            sequential_label_row("GPU Manufacturer:", &values_grid, &mut row);
-        let family_name = sequential_label_row("GPU Family:", &values_grid, &mut row);
-        let asic_name = sequential_label_row("ASIC Name:", &values_grid, &mut row);
-        let compute_units_label = sequential_label_row("Compute Units:", &values_grid, &mut row);
-        let vbios_version_label = sequential_label_row("VBIOS Version:", &values_grid, &mut row);
-        let driver_label = sequential_label_row("Driver Used:", &values_grid, &mut row);
-
-        let vram_size_label = sequential_label_row("VRAM Size:", &values_grid, &mut row);
-        let vram_type_label = sequential_label_row("VRAM Type:", &values_grid, &mut row);
-        let vram_peak_bw_label =
-            sequential_label_row("Peak VRAM Bandwidth:", &values_grid, &mut row);
-
-        let l1_cache_label = sequential_label_row("L1 Cache (Per CU):", &values_grid, &mut row);
-        let l2_cache_label = sequential_label_row("L2 Cache:", &values_grid, &mut row);
-        let l3_cache_label = sequential_label_row("L3 Cache:", &values_grid, &mut row);
-
-        let resizable_bar_enabled = sequential_label_row("Resizeable BAR:", &values_grid, &mut row);
-        let cpu_accessible_vram_label =
-            sequential_label_row("CPU Accessible VRAM:", &values_grid, &mut row);
-        let link_speed_label = sequential_label_row("Link Speed:", &values_grid, &mut row);
-
-        info_container.append(&values_grid);
+        let info_listbox = ListBox::builder()
+            .css_classes(["boxed-list"])
+            .selection_mode(SelectionMode::None)
+            .build();
+
+        let gpu_name_row = InfoRow::new("GPU Model");
+        let gpu_manufacturer_row = InfoRow::new("GPU Manufacturer");
+        let family_name_row = InfoRow::new("GPU Family");
+        let asic_name_row = InfoRow::new("ASIC Name");
+        let compute_units_row = InfoRow::new("Compute Units");
+        let vbios_version_row = InfoRow::new("VBIOS Version");
+        let driver_row = InfoRow::new("Driver Used");
+
+        let vram_size_row = InfoRow::new("VRAM Size");
+        let vram_type_row = InfoRow::new("VRAM Type");
+        let vram_peak_bw_row = InfoRow::new("Peak VRAM Bandwidth");
+
+        let l1_cache_row = InfoRow::new("L1 Cache (Per CU)");
+        let l2_cache_row = InfoRow::new("L2 Cache");
+        let l3_cache_row = InfoRow::new("L3 Cache");
+
+        let resizable_bar_enabled_row = InfoRow::new("Resizeable BAR");
+        let cpu_accessible_vram_row = InfoRow::new("CPU Accessible VRAM");
+        let link_speed_row = InfoRow::new("Link Speed");
+
+        info_listbox.append(&gpu_name_row.container);
+        info_listbox.append(&gpu_manufacturer_row.container);
+        info_listbox.append(&family_name_row.container);
+        info_listbox.append(&asic_name_row.container);
+        info_listbox.append(&compute_units_row.container);
+        info_listbox.append(&vbios_version_row.container);
+        info_listbox.append(&driver_row.container);
+        info_listbox.append(&vram_size_row.container);
+        info_listbox.append(&vram_type_row.container);
+        info_listbox.append(&vram_peak_bw_row.container);
+        info_listbox.append(&l1_cache_row.container);
+        info_listbox.append(&l2_cache_row.container);
+        info_listbox.append(&l3_cache_row.container);
+        info_listbox.append(&resizable_bar_enabled_row.container);
+        info_listbox.append(&cpu_accessible_vram_row.container);
+        info_listbox.append(&link_speed_row.container);
+        info_container.append(&info_listbox);
         vbox.append(&info_container);
 
         let vulkan_container = PageSection::new("Vulkan Information");
@@ -81,71 +117,77 @@ impl InformationPage {
 
         let vulkan_unavailable_label = Label::builder()
             .label("Vulkan is not available on this GPU")
+            .css_classes(["error"])
             .visible(false)
-            .margin_start(10)
-            .margin_end(10)
-            .halign(Align::Start)
+            .xalign(0.0)
             .build();
         vulkan_container.append(&vulkan_unavailable_label);
 
         vbox.append(&vulkan_container);
 
+        let clamp = libadwaita::Clamp::builder()
+            .maximum_size(600)
+            .margin_top(24)
+            .margin_bottom(24)
+            .child(&vbox)
+            .build();
+
         let container = ScrolledWindow::builder()
             .hscrollbar_policy(PolicyType::Never)
-            .child(&vbox)
+            .child(&clamp)
             .build();
 
         Self {
             container,
-            gpu_name_label,
-            gpu_manufacturer_label,
-            vbios_version_label,
-            driver_label,
-            vram_size_label,
-            link_speed_label,
+            gpu_name_row,
+            gpu_manufacturer_row,
+            vbios_version_row,
+            driver_row,
+            vram_size_row,
+            link_speed_row,
             vulkan_info_frame,
-            family_name,
-            asic_name,
-            vram_type_label,
-            resizable_bar_enabled,
-            cpu_accessible_vram_label,
-            compute_units_label,
-            vram_peak_bw_label,
-            l1_cache_label,
-            l2_cache_label,
-            l3_cache_label,
+            family_name_row,
+            asic_name_row,
+            vram_type_row,
+            resizable_bar_enabled_row,
+            cpu_accessible_vram_row,
+            compute_units_row,
+            vram_peak_bw_row,
+            l1_cache_row,
+            l2_cache_row,
+            l3_cache_row,
             vulkan_unavailable_label,
         }
     }
 
     pub fn set_info(&self, gpu_info: &DeviceInfo) {
-        let gpu_name = gpu_info
-            .pci_info
-            .as_ref()
-            .and_then(|pci_info| {
-                pci_info
-                    .subsystem_pci_info
-                    .model
-                    .as_deref()
-                    .or(pci_info.device_pci_info.model.as_deref())
-            })
-            .unwrap_or_default();
-        self.gpu_name_label
-            .set_markup(&format!("<b>{gpu_name}</b>"));
-
-        let gpu_manufacturer = gpu_info
-            .pci_info
-            .as_ref()
-            .and_then(|pci_info| {
-                pci_info
-                    .subsystem_pci_info
-                    .vendor
-                    .as_deref()
-                    .or(pci_info.device_pci_info.model.as_deref())
-            })
-            .unwrap_or_default();
-        self.gpu_manufacturer_label
-            .set_markup(&format!("<b>{gpu_manufacturer}</b>"));
+        self.gpu_name_row.set_content(
+            gpu_info
+                .pci_info
+                .as_ref()
+                .and_then(|pci_info| {
+                    pci_info
+                        .subsystem_pci_info
+                        .model
+                        .as_deref()
+                        .or(pci_info.device_pci_info.model.as_deref())
+                })
+                .unwrap_or_default(),
+        );
+
+        self.gpu_manufacturer_row.set_content(
+            gpu_info
+                .pci_info
+                .as_ref()
+                .and_then(|pci_info| {
+                    pci_info
+                        .subsystem_pci_info
+                        .vendor
+                        .as_deref()
+                        .or(pci_info.device_pci_info.model.as_deref())
+                })
+                .unwrap_or_default(),
+        );
 
         let mut family_name = "Unknown";
         let mut asic_name = "Unknown";
@@ -179,47 +221,35 @@ impl InformationPage {
             }
         }
 
-        self.family_name
-            .set_markup(&format!("<b>{family_name}</b>"));
-        self.asic_name.set_markup(&format!("<b>{asic_name}</b>"));
-        self.compute_units_label
-            .set_markup(&format!("<b>{compute_units}</b>"));
-        self.vram_type_label
-            .set_markup(&format!("<b>{vram_type}</b>"));
-        self.vram_peak_bw_label
-            .set_markup(&format!("<b>{vram_max_bw} GiB/s</b>"));
-
-        self.l1_cache_label
-            .set_markup(&format!("<b>{l1_cache}</b>"));
-        self.l2_cache_label
-            .set_markup(&format!("<b>{l2_cache}</b>"));
-        self.l3_cache_label
-            .set_markup(&format!("<b>{l3_cache}</b>"));
-
-        self.resizable_bar_enabled
-            .set_markup(&format!("<b>{resizeable_bar_enabled}</b>"));
-        self.cpu_accessible_vram_label
-            .set_markup(&format!("<b>{cpu_accessible_vram} MiB</b>"));
-
-        let vbios_version = gpu_info.vbios_version.as_deref().unwrap_or("Unknown");
-        self.vbios_version_label
-            .set_markup(&format!("<b>{vbios_version}</b>"));
-
-        self.driver_label
-            .set_markup(&format!("<b>{}</b>", gpu_info.driver));
-
-        let link_speed = gpu_info
-            .link_info
-            .current_speed
-            .as_deref()
-            .unwrap_or("Unknown");
-        let link_width = gpu_info
-            .link_info
-            .current_width
-            .as_deref()
-            .unwrap_or("Unknown");
-        self.link_speed_label
-            .set_markup(&format!("<b>{link_speed} x{link_width}</b>",));
+        self.family_name_row.set_content(family_name);
+        self.asic_name_row.set_content(asic_name);
+        self.compute_units_row.set_content(&compute_units);
+        self.vbios_version_row
+            .set_content(gpu_info.vbios_version.as_deref().unwrap_or("Unknown"));
+        self.driver_row.set_content(gpu_info.driver);
+        self.vram_type_row.set_content(vram_type);
+        self.vram_peak_bw_row
+            .set_content(&format!("{vram_max_bw} GiB/s"));
+        self.l1_cache_row.set_content(&l1_cache);
+        self.l2_cache_row.set_content(&l2_cache);
+        self.l3_cache_row.set_content(&l3_cache);
+        self.resizable_bar_enabled_row
+            .set_content(resizeable_bar_enabled);
+        self.cpu_accessible_vram_row
+            .set_content(&cpu_accessible_vram);
+        self.link_speed_row.set_content(&format!(
+            "{link_speed} x{link_width}",
+            link_speed = gpu_info
+                .link_info
+                .current_speed
+                .as_deref()
+                .unwrap_or("Unknown"),
+            link_width = gpu_info
+                .link_info
+                .current_width
+                .as_deref()
+                .unwrap_or("Unknown")
+        ));
 
         if let Some(vulkan_info) = &gpu_info.vulkan_info {
             self.vulkan_info_frame.set_info(vulkan_info);
@@ -236,13 +266,6 @@ impl InformationPage {
             || "Unknown".to_owned(),
             |size| (size / 1024 / 1024).to_string(),
         );
-        self.vram_size_label
-            .set_markup(&format!("<b>{vram_size} MiB</b>"));
+        self.vram_size_row.set_content(&format!("{vram_size} MiB"));
     }
 }
-
-fn sequential_label_row(title: &str, parent: &Grid, row: &mut i32) -> Label {
-    let label = label_row(title, parent, *row, 0, true);
-    *row += 1;
-    label
-}
diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
index 6da11dd7..c3c25fd1 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
@@ -2,60 +2,73 @@ mod feature_window;
 
 use self::feature_window::VulkanFeaturesWindow;
 
-use super::values_grid;
 use crate::app::root_stack::info_page::vulkan_info::feature_window::feature::VulkanFeature;
-use crate::app::root_stack::{label_row, values_row};
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::VulkanInfo;
+use libadwaita::prelude::ActionRowExt;
 use tracing::trace;
 
+use super::InfoRow;
+
 #[derive(Clone)]
 pub struct VulkanInfoFrame {
-    pub container: Box,
-    device_name_label: Label,
-    version_label: Label,
-    driver_name_label: Label,
-    driver_version_label: Label,
+    pub container: ListBox,
+    device_name_row: InfoRow,
+    version_row: InfoRow,
+    driver_name_row: InfoRow,
+    driver_version_row: InfoRow,
     features_model: gio::ListStore,
     extensions_model: gio::ListStore,
 }
 
 impl VulkanInfoFrame {
     pub fn new() -> Self {
-        let container = Box::new(Orientation::Vertical, 0);
+        let container = ListBox::builder()
+            .css_classes(["boxed-list"])
+            .selection_mode(SelectionMode::None)
+            .build();
 
         let features_model = gio::ListStore::new::<VulkanFeature>();
         let extensions_model = gio::ListStore::new::<VulkanFeature>();
 
-        let grid = values_grid();
-
-        let device_name_label = label_row("Device name", &grid, 0, 0, true);
-        let version_label = label_row("Vulkan version:", &grid, 1, 0, true);
-        let driver_name_label = label_row("Driver name:", &grid, 2, 0, true);
-        let driver_version_label = label_row("Driver version:", &grid, 3, 0, true);
-
-        let show_features_button = Button::builder().label("Show").halign(Align::End).build();
-        show_features_button.connect_clicked(clone!(@strong features_model => move |_| {
+        let device_name_row = InfoRow::new("Device name");
+        let version_row = InfoRow::new("Vulkan version");
+        let driver_name_row = InfoRow::new("Driver name");
+        let driver_version_row = InfoRow::new("Driver version");
+
+        container.append(&device_name_row.container);
+        container.append(&version_row.container);
+        container.append(&driver_name_row.container);
+        container.append(&driver_version_row.container);
+
+        let features_row = libadwaita::ActionRow::builder()
+            .activatable(true)
+            .title("Features")
+            .build();
+        features_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
+        features_row.connect_activated(clone!(@strong features_model => move |_| {
             show_features_window("Vulkan features", features_model.clone());
         }));
-        values_row("Features:", &grid, &show_features_button, 4, 0);
-
-        let show_extensions_button = Button::builder().label("Show").halign(Align::End).build();
-        show_extensions_button.connect_clicked(clone!(@strong extensions_model => move |_| {
+        container.append(&features_row);
+
+        let extensions_row = libadwaita::ActionRow::builder()
+            .activatable(true)
+            .title("Extensions")
+            .build();
+        extensions_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
+        extensions_row.connect_activated(clone!(@strong extensions_model => move |_| {
             show_features_window("Vulkan extensions", extensions_model.clone());
         }));
-        values_row("Extensions:", &grid, &show_extensions_button, 5, 0);
-
-        container.append(&grid);
+        container.append(&extensions_row);
 
         Self {
             container,
-            device_name_label,
-            version_label,
-            driver_name_label,
-            driver_version_label,
+            device_name_row,
+            version_row,
+            driver_name_row,
+            driver_version_row,
             features_model,
             extensions_model,
         }
@@ -64,20 +77,14 @@ impl VulkanInfoFrame {
     pub fn set_info(&self, vulkan_info: &VulkanInfo) {
         trace!("setting vulkan info: {:?}", vulkan_info);
 
-        self.device_name_label
-            .set_markup(&format!("<b>{}</b>", vulkan_info.device_name));
-        self.version_label
-            .set_markup(&format!("<b>{}</b>", vulkan_info.api_version));
+        self.device_name_row.set_content(&vulkan_info.device_name);
+        self.version_row.set_content(&vulkan_info.api_version);
 
-        self.driver_name_label.set_markup(&format!(
-            "<b>{}</b>",
-            vulkan_info.driver.name.as_deref().unwrap_or_default(),
-        ));
+        self.driver_name_row
+            .set_content(&vulkan_info.driver.name.as_deref().unwrap_or_default());
 
-        self.driver_version_label.set_markup(&format!(
-            "<b>{}</b>",
-            vulkan_info.driver.info.as_deref().unwrap_or_default(),
-        ));
+        self.driver_version_row
+            .set_content(&vulkan_info.driver.info.as_deref().unwrap_or_default());
 
         self.features_model.remove_all();
         for (name, supported) in &vulkan_info.features {
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 68f3e731..3a190270 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -21,12 +21,7 @@ pub struct RootStack {
 
 impl RootStack {
     pub fn new(system_info: SystemInfo, embedded_daemon: bool) -> Self {
-        let container = Stack::builder()
-            .vexpand(true)
-            .margin_top(15)
-            .margin_start(30)
-            .margin_end(30)
-            .build();
+        let container = Stack::builder().vexpand(true).hexpand(true).build();
 
         let info_page = InformationPage::new();
 
@@ -52,6 +47,7 @@ impl RootStack {
     }
 }
 
+#[deprecated]
 fn values_row<W: IsA<Widget>>(
     title: &str,
     parent: &Grid,
@@ -65,6 +61,7 @@ fn values_row<W: IsA<Widget>>(
     parent.attach(value_child, column_offset + 1, row, 1, 1);
 }
 
+#[deprecated]
 fn label_row(title: &str, parent: &Grid, row: i32, column_offset: i32, selectable: bool) -> Label {
     let value_label = Label::builder()
         .halign(Align::End)
@@ -76,6 +73,7 @@ fn label_row(title: &str, parent: &Grid, row: i32, column_offset: i32, selectabl
     value_label
 }
 
+#[deprecated]
 fn values_grid() -> Grid {
     Grid::builder()
         .margin_start(10)
diff --git a/lact-gui/ui/page_section.blp b/lact-gui/ui/page_section.blp
index a00d6ac3..f8e61900 100644
--- a/lact-gui/ui/page_section.blp
+++ b/lact-gui/ui/page_section.blp
@@ -2,14 +2,10 @@ using Gtk 4.0;
 
 template $PageSection: Box {
     orientation: vertical;
-    spacing: 5;
-    margin-start: 5;
-    margin-end: 5;
+    spacing: 12;
 
     Label section_label {
+        styles ["title-3"]
         halign: start;
-        use-markup: true;
-        margin-top: 5;
-        margin-bottom: 5;
     }
 }

